package service

import (
	"errors"

    "github.com/go-admin-team/go-admin-core/sdk/service"
	"gorm.io/gorm"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
	cDto "go-admin/common/dto"
)

type LineOrderTemplateLogs struct {
	service.Service
}

// GetPage 获取LineOrderTemplateLogs列表
func (e *LineOrderTemplateLogs) GetPage(c *dto.LineOrderTemplateLogsGetPageReq, p *actions.DataPermission, list *[]models.LineOrderTemplateLogs, count *int64) error {
	var err error
	var data models.LineOrderTemplateLogs

	err = e.Orm.Model(&data).
		Scopes(
			cDto.MakeCondition(c.GetNeedSearch()),
			cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
			actions.Permission(data.TableName(), p),
		).
		Find(list).Limit(-1).Offset(-1).
		Count(count).Error
	if err != nil {
		e.Log.Errorf("LineOrderTemplateLogsService GetPage error:%s \r\n", err)
		return err
	}
	return nil
}

// Get 获取LineOrderTemplateLogs对象
func (e *LineOrderTemplateLogs) Get(d *dto.LineOrderTemplateLogsGetReq, p *actions.DataPermission, model *models.LineOrderTemplateLogs) error {
	var data models.LineOrderTemplateLogs

	err := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).
		First(model, d.GetId()).Error
	if err != nil && errors.Is(err, gorm.ErrRecordNotFound) {
		err = errors.New("查看对象不存在或无权查看")
		e.Log.Errorf("Service GetLineOrderTemplateLogs error:%s \r\n", err)
		return err
	}
	if err != nil {
		e.Log.Errorf("db error:%s", err)
		return err
	}
	return nil
}

// Insert 创建LineOrderTemplateLogs对象
func (e *LineOrderTemplateLogs) Insert(c *dto.LineOrderTemplateLogsInsertReq) error {
    var err error
    var data models.LineOrderTemplateLogs
    c.Generate(&data)
	err = e.Orm.Create(&data).Error
	if err != nil {
		e.Log.Errorf("LineOrderTemplateLogsService Insert error:%s \r\n", err)
		return err
	}
	return nil
}

// Update 修改LineOrderTemplateLogs对象
func (e *LineOrderTemplateLogs) Update(c *dto.LineOrderTemplateLogsUpdateReq, p *actions.DataPermission) error {
    var err error
    var data = models.LineOrderTemplateLogs{}
    e.Orm.Scopes(
            actions.Permission(data.TableName(), p),
        ).First(&data, c.GetId())
    c.Generate(&data)

    db := e.Orm.Save(&data)
    if err = db.Error; err != nil {
        e.Log.Errorf("LineOrderTemplateLogsService Save error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权更新该数据")
    }
    return nil
}

// Remove 删除LineOrderTemplateLogs
func (e *LineOrderTemplateLogs) Remove(d *dto.LineOrderTemplateLogsDeleteReq, p *actions.DataPermission) error {
	var data models.LineOrderTemplateLogs

	db := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).Delete(&data, d.GetId())
	if err := db.Error; err != nil {
        e.Log.Errorf("Service RemoveLineOrderTemplateLogs error:%s \r\n", err)
        return err
    }
    if db.RowsAffected == 0 {
        return errors.New("无权删除该数据")
    }
	return nil
}
